-----------------------------------------------------------------------
--
--  File:        ms_dos.adb
--  Description: Interface to DJGPP v2.0 MS-DOS library
--  Rev:         0.1
--  Date:        03/09/96
--  Author:      Jerry van Dijk
--  Mail:        jerry@jvdsys.nextjk.stuyts.nl
--
--  Copyright (c) Jerry van Dijk, 1996
--  Forelstraat 211
--  2037 KV  HAARLEM
--  THE NETHERLANDS
--  tel int + 31 23 540 1052
--
--  Permission granted to use for any purpose, provided this copyright
--  remains attached and unmodified.
--
--  THIS SOFTWARE IS PROVIDED ``AS IS'' AND WITHOUT ANY EXPRESS OR
--  IMPLIED WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED
--  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
--
-----------------------------------------------------------------------

package body MS_DOS is

   -----------------------------------------------
   -- Import the intrinsic shift_right function --
   -----------------------------------------------

   function Shift_Right (Value : unsigned_32;
                         Count : Natural) return unsigned_32;
   pragma Import (Intrinsic, Shift_Right);


   -----------------------------------------------------------
   -- Convert a linear adress into its real-mode equivalent --
   -----------------------------------------------------------

   function RM_Offset (Address : unsigned_32) return unsigned_16 is
   begin
      return unsigned_16 (Address and 16#0F#);
   end RM_Offset;

   function RM_Segment (Address : unsigned_32) return unsigned_16 is
   begin
      return unsigned_16 (Shift_Right (Address, 4) and 16#FFFF#);
   end RM_Segment;


   ---------------------------------------------------------
   -- Convert a DWORD real-mode address into a linear one --
   ---------------------------------------------------------

   function RM_To_Linear (Address : unsigned_32) return unsigned_32 is
   begin
      return 16 * Shift_Right (Address, 16) + (Address and 16#FFFF#);
   end RM_To_Linear;

end MS_DOS;